Package com.io7m.cardant.model

# Record Class CAFileID

java.lang.Object
java.lang.Record
com.io7m.cardant.model.CAFileID

Record Components:
  `id` - The ID value

All Implemented Interfaces:
  `CAIdType`, `Comparable<CAFileID>`

public record CAFileID(UUID id) extends Record implements Comparable<CAFileID>, CAIdType
The unique ID of an file.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CAFileID(UUID id)`
  The unique ID of an file.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `compareTo(CAFileID other)`
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `UUID`
  `id()`
  Returns the value of the `id` record component.
  `static CAFileID`
  `of(String id)`
  Construct an ID.
  `static CAFileID`
  `of(UUID id)`
  Construct an ID.
  `static CAFileID`
  `random()`
  Construct an ID using a pseudorandom value.
  `String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.io7m.cardant.model.CAIdType

  `displayId`

- ## Constructor Details

  - ### CAFileID

    public CAFileID(UUID id)
    The unique ID of an file.
    Parameters:
      `id` - The ID value

- ## Method Details

  - ### toString

    public String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### of

    public static CAFileID of(String id)
    Construct an ID.
    Parameters:
      `id` - The ID value
    Returns:
      An ID

  - ### of

    public static CAFileID of(UUID id)
    Construct an ID.
    Parameters:
      `id` - The ID value
    Returns:
      An ID

  - ### random

    public static CAFileID random()
    Construct an ID using a pseudorandom value.
    Returns:
      An ID

  - ### compareTo

    public int compareTo(CAFileID other)
    Specified by:
      `compareTo` in interface `Comparable<CAFileID>`

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### id

    public UUID id()
    Returns the value of the `id` record component.
    Specified by:
      `id` in interface `CAIdType`
    Returns:
      the value of the `id` record component